Bug 99300 - 15bit visuals under Sierra?
Summary: 15bit visuals under Sierra?
Status: RESOLVED MOVED
Alias: None
Product: XQuartz
Classification: Unclassified
Component: New Bugs (show other bugs)
Version: 2.7.11 (xserver-1.18.4)
Hardware: x86 (IA32) Mac OS X (All)
: medium normal
Assignee: Jeremy Huddleston Sequoia
QA Contact: Jeremy Huddleston Sequoia
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2017-01-06 16:58 UTC by fwd7
Modified: 2019-05-23 18:31 UTC (History)
0 users

See Also:
i915 platform:
i915 features:


Attachments

Description fwd7 2017-01-06 16:58:50 UTC
Support for 15bit visuals were removed in XQuartz 2.7.5 - please put it back!

Old tickets on github mentioned that 15bit visuals were removed because the libXplugin on Mountain Lion did not support it. Is this still the case on the current version of libXplugin used by Sierra? (There is no recent discussion/bug report on bugs.freedesktop.org, as far I could find.)

XQuartz | Preferences | Output | Colors lists a line for Thousands colors, which translates into a value of 15 for depth in the org.macosforge.xquartz.X11.plist preference file.

But when I use xwininfo, I get:
  Depth: 24
  Visual: 0x22
  Visual Class: TrueColor

And calling XDefaultDepth returns a value of 24, too.

(If 15bit is not feasible, please at least remove the line for Thousands colors in the XQuartz.app's GUI.)
Comment 1 Jeremy Huddleston Sequoia 2017-01-08 17:47:58 UTC
What "Old tickets on github" are you referring to?
Comment 2 fwd7 2017-01-08 17:59:31 UTC
The latest that I found discussing 15bit for XQuartz are the following:

https://github.com/XQuartz/xquartz.github.io/blob/master/_releases/XQuartz-2.7.5.md

https://github.com/XQuartz/xquartz-old-tickets/blob/master/ticket/633.md

I get the gist that 15bit posed some problems back then and that you removed it. The application I'd like to run under XQuartz (supposedly) runs in all of 8bit, 15bit, 24bit and 32bit modes, so I would like to test/use it in all of those modes. XQuartz.App offers - in its GUI - 8bit, 15bit and 24bit. But when I choose 15bit ("Thousands"), I get 24bit nonetheless, right? And there is no 32bit, right? 

Can you please put 15bit back into XQuartz? Can you (or do you already) also offer 32bit?
Comment 3 Jeremy Huddleston Sequoia 2017-01-08 18:31:39 UTC
If you have a need for it and want to add in support for it (likely needing to re-encode it as a 32bit visual before handing off to CG), such a change would be accepted.

There isn't anyone actively working on XQuartz these days (and there hasn't been for about 5 years), so anything more than very minor changes or security issues is not really going to happen without more community involvement..
Comment 4 fwd7 2017-01-10 15:44:59 UTC
Well, could you at least reply to my questions? In particular:

1.  Is 15bit in the current version of XQuartz available or not?

1a.  If 15bit is available, why are we unable to start in that mode? xwininfo returns depth=24

1b.  If 15bit is not available, why is that mode then listed in the GUI? XQuartz.app | Preferences | Output | Colors lists a line for "Thousands" colors.


2.  Why was 15bit support removed from XQuartz 2.7.5 and later?

2a.  Is the reason for which it was removed still valid? For example, does libXplugin still pose a problem for 15bit? Or has it been updated?

2b.  If the reason is not valid any more, why don't you re-allow it? xwininfo returns depth=24


3. Is 32bit in the current version of XQuartz available or not?


4. My humble understanding is that only 8bit and 24bit are currently available in XQuartz. Is this correct?

4a.  Wouldn't it be honest to show this in the GUI? XQuartz.app | Preferences | Output | Colors should simply show two lines:

- 256 Colors (8 bit)
- Millions (24 bit)

4b.  I think even the line saying "From Display" is misleading. Shouldn't it be removed? In fact, most current Macs (including the low-end iMac 4K) have a 30bit screen. But XQuartz runs in 24bit max., it appears to me. So, the GUI should only list 256 Colors (8 bit) and Millions (24 bit), nothing else.

This should be fairly straightforward to implement and it would make it much clearer to the more casual user of XQuartz.
Comment 5 Jeremy Huddleston Sequoia 2017-01-11 02:33:50 UTC
(In reply to fwd7 from comment #4)
> Well, could you at least reply to my questions? In particular:
> 
> 1.  Is 15bit in the current version of XQuartz available or not?

As you referenced earlier, no it is not.

> 1b.  If 15bit is not available, why is that mode then listed in the GUI?
> XQuartz.app | Preferences | Output | Colors lists a line for "Thousands"
> colors.

As you mentioned earlier, that's a bug in the preference window.

> 2.  Why was 15bit support removed from XQuartz 2.7.5 and later?

Because Apple removed support for it.

> 2a.  Is the reason for which it was removed still valid? 

Yes.

> For example, does
> libXplugin still pose a problem for 15bit? Or has it been updated?

libXplugin isn't the problem.  CoreGraphics behind libXplugin is the problem.  CG won't regain support for 15bit color.

> 3. Is 32bit in the current version of XQuartz available or not?

Yes.

> 4. My humble understanding is that only 8bit and 24bit are currently
> available in XQuartz. Is this correct?

24bit is 32bit without alpha.

8bit is indexed.  I believe it's no longer supported either.

> 4a.  Wouldn't it be honest to show this in the GUI? XQuartz.app |
> Preferences | Output | Colors should simply show two lines:
> 
> - 256 Colors (8 bit)
> - Millions (24 bit)

It'd be better to just remove that section from the UI entirely.

> This should be fairly straightforward to implement and it would make it much
> clearer to the more casual user of XQuartz.

Yes, please do submit a patch.
Comment 6 GitLab Migration User 2019-05-23 18:31:41 UTC
-- GitLab Migration Automatic Message --

This bug has been migrated to freedesktop.org's GitLab instance and has been closed from further activity.

You can subscribe and participate further through the new bug through this link to our GitLab instance: https://gitlab.freedesktop.org/xorg/xserver/issues/780.


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.